"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _factory = require("./factory");

var _factory2 = _interopRequireDefault(_factory);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Memory = function () {
  function Memory() {
    (0, _classCallCheck3.default)(this, Memory);
  }

  (0, _createClass3.default)(Memory, [{
    key: "init",
    value: function init() {
      this.cache = {};
    }
  }, {
    key: "pattern",
    value: function pattern() {
      return {
        getCache: { cached: true }
      };
    }
  }, {
    key: "cacheStatus",
    value: function cacheStatus(_ref) {
      var name = _ref.name;

      return { cached: !!this.cache[name] };
    }
  }, {
    key: "getCache",
    value: function getCache(_ref2) {
      var name = _ref2.name;

      return this.cache[name];
    }
  }, {
    key: "get",
    value: function get() {
      return [this.cacheStatus, this.getCache];
    }
  }, {
    key: "set",
    value: function set() {
      return [this.cacheStatus, this.setCache];
    }
  }, {
    key: "setCache",
    value: function setCache(_ref3) {
      var name = _ref3.name;
      var variant = _ref3.variant;
      var data = _ref3.data;

      this.cache[name] = { variant: variant, data: data };
      return {};
    }
  }]);
  return Memory;
}();

exports.default = (0, _factory2.default)(Memory);
//# sourceMappingURL=memory.js.map